package com.zztrapp.zztrapp.ui.index.adapter;


import android.annotation.SuppressLint;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.google.android.flexbox.FlexboxLayoutManager;
import com.zztrapp.zztrapp.bean.RcrwPagelistBean;
import com.zztrapp.zztrapp.databinding.ItemRvSpecialTasksBinding;
import com.zztrapp.zztrapp.ui.currency.adapter.FlexBoxItemAdapter;

import java.util.ArrayList;
import java.util.List;

/**
 * Describe 日常任务-首页
 * Created by Bby on 2022/6/23
 * Email bby0856@163.com
 */

public class DailyTasksAdapter extends RecyclerView.Adapter<DailyTasksAdapter.ItemHolder> {

    private Context mContext;
    private OnItemClickListener onItemClickListener;
    private List<RcrwPagelistBean.RecordsBean> list;

    public interface OnItemClickListener {
        void onEditClick(String id, int position);

        void onLookDetailClick(String id, int position);
    }

    public void setOnItemClickListener(OnItemClickListener onItemClickListener) {
        this.onItemClickListener = onItemClickListener;
    }

    public DailyTasksAdapter(Context context) {
        this.mContext = context;
    }

    public void setData(List<RcrwPagelistBean.RecordsBean> list) {
        this.list = list;
        notifyDataSetChanged();
    }

    @NonNull
    @Override
    public ItemHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        ItemRvSpecialTasksBinding binding = ItemRvSpecialTasksBinding.inflate(LayoutInflater.from(mContext), parent, false);
        return new ItemHolder(binding);
    }

    @Override
    public void onBindViewHolder(ItemHolder holder, @SuppressLint("RecyclerView") int position) {
        holder.bindings.taskName.setText("任务名称 " + list.get(position).getRwmc());
        List<String> arrayList = new ArrayList<>();
        arrayList.add("任务时间：" + list.get(position).getRwsj());
        arrayList.add("任务人：" + list.get(position).getRmr());
        holder.bindings.rv.setLayoutManager(new FlexboxLayoutManager(mContext));
        FlexBoxItemAdapter adapter = new FlexBoxItemAdapter(mContext);
        holder.bindings.rv.setAdapter(adapter);
        adapter.setData(arrayList);

        holder.bindings.edit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (onItemClickListener != null) {
                    onItemClickListener.onEditClick(list.get(position).getId(), position);
                }
            }
        });
        holder.bindings.lookDetail.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (onItemClickListener != null) {
                    onItemClickListener.onLookDetailClick(list.get(position).getId(), position);
                }
            }
        });
    }

    @Override
    public int getItemCount() {
        return list != null ? list.size() : 0;
    }

    static class ItemHolder extends RecyclerView.ViewHolder {
        private ItemRvSpecialTasksBinding bindings;

        public ItemHolder(ItemRvSpecialTasksBinding binding) {
            super(binding.getRoot());
            bindings = binding;
        }
    }
}